package me.wazup.hideandseek;

import org.bukkit.entity.Player;
import java.util.Iterator;
import org.bukkit.configuration.file.FileConfiguration;
import java.sql.ResultSet;
import java.util.Collections;
import java.util.Comparator;
import java.util.Collection;
import java.util.LinkedList;
import me.wazup.hideandseek.managers.FilesManager;
import java.sql.SQLException;
import java.util.HashMap;
import java.util.Map;
import java.util.List;

public class HideAndSeekAPI
{
    public static List<Map.Entry<String, Integer>> getTopPlayers(final int n) {
        final HideAndSeek instance = HideAndSeek.getInstance();
        final HashMap hashMap = new HashMap();
        if (Config.getInstance().mysql_enabled) {
            try {
                final ResultSet executeQuery = instance.mysql.getConnection().createStatement().executeQuery("SELECT * FROM " + instance.mysql.tableName + " ORDER BY wins DESC");
                for (int n2 = 0; n2 < n && executeQuery.next(); ++n2) {
                    final String string = executeQuery.getString("player_name");
                    hashMap.put(string, instance.playerData.containsKey(string) ? instance.playerData.get(string).wins : executeQuery.getInt("wins"));
                }
                executeQuery.close();
            }
            catch (final SQLException ex) {
                ex.printStackTrace();
            }
        }
        else {
            final FileConfiguration config = FilesManager.getInstance().getConfig("players.yml");
            if (config.getConfigurationSection("Players") != null) {
                for (final String s : config.getConfigurationSection("Players").getKeys(false)) {
                    final String string2 = config.getString("Players." + s + ".Name");
                    hashMap.put(string2, instance.playerData.containsKey(string2) ? instance.playerData.get(string2).wins : config.getInt("Players." + s + ".wins"));
                }
            }
        }
        if (hashMap.size() < n) {
            for (int i = hashMap.size(); i < n; ++i) {
                hashMap.put("NO_PLAYER" + i, 0);
            }
        }
        final LinkedList list = new LinkedList<Object>(hashMap.entrySet());
        Collections.sort((List<E>)list, (Comparator<? super E>)new Comparator<Map.Entry<String, Integer>>() {
            @Override
            public int compare(final Map.Entry<String, Integer> entry, final Map.Entry<String, Integer> entry2) {
                return entry2.getValue() - entry.getValue();
            }
        });
        return (List<Map.Entry<String, Integer>>)list;
    }
    
    public static PlayerData getPlayerData(final Player player) {
        return HideAndSeek.getInstance().playerData.get(player.getName());
    }
}
